package ogloszenia.klient;

import jakarta.xml.ws.Service;
import ogloszenia.exn.BladBazyDanych;
import ogloszenia.model.OgloszenieSamochodowe;
import ogloszenia.soap.Ogloszenia;

import javax.xml.namespace.QName;
import java.util.List;

public class Klient1_OdczytajWszystkie {
    public static void main(String[] args) {
        try {
            System.out.println("Startujemy...");
            Service service = null; //Service.create("", new QName("", ""));
            Ogloszenia proxy = service.getPort(Ogloszenia.class);

            System.out.println("Wysyłam zapytanie");
            List<OgloszenieSamochodowe> lista = proxy.readAll();
            System.out.println("Odczytano " + lista.size() + " ogłoszeń:");
            for (OgloszenieSamochodowe ogloszenie : lista) {
                System.out.println(ogloszenie.getMarka() + " " + ogloszenie.getModel() + " za " + ogloszenie.getCena());
            }
        } catch (BladBazyDanych e) {
            System.out.println(e);
        } catch (Exception e) {
            System.out.println("Inny błąd: " + e);
            e.printStackTrace();
        }
    }
}
