package ogloszenia.soap;

import jakarta.jws.WebParam;
import jakarta.jws.WebResult;
import jakarta.jws.WebService;
import ogloszenia.exn.BladBazyDanych;
import ogloszenia.exn.NieznanyRekord;
import ogloszenia.model.OgloszenieSamochodowe;

import java.io.IOException;
import java.math.BigDecimal;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.List;

@WebService
public interface Ogloszenia {

    @WebResult(name="ogloszenie")
    public List<OgloszenieSamochodowe> readAll() throws BladBazyDanych;

    @WebResult(name="ogloszenie")
    public OgloszenieSamochodowe readOne(@WebParam(name="id") int idOgloszenia) throws BladBazyDanych, NieznanyRekord;

    @WebResult(name="ogloszenie")
    public List<OgloszenieSamochodowe> readByPrice(
            @WebParam(name="min") BigDecimal min,
            @WebParam(name="max") BigDecimal max) throws BladBazyDanych;

    public void update(
            @WebParam(name="ogloszenie") OgloszenieSamochodowe ogloszenie) throws BladBazyDanych, NieznanyRekord;

    @WebResult(name="new-id")
    public int insert(
            @WebParam(name="ogloszenie") OgloszenieSamochodowe ogloszenie) throws BladBazyDanych;

    @WebResult(name="bytes")
    public byte[] photo(@WebParam(name="id") int idOgloszenia) throws NieznanyRekord;
}
